<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - report.info - QtWidgets/qwidget.h</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">QtWidgets</a> - qwidget.h<span style="font-size: 80%;"> (source / <a href="qwidget.h.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">report.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">4</td>
            <td class="headerCovTableEntry">4</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2021-03-29 02:25:54</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">2</td>
            <td class="headerCovTableEntry">2</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : /****************************************************************************</a>
<a name="2"><span class="lineNum">       2 </span>            : **</a>
<a name="3"><span class="lineNum">       3 </span>            : ** Copyright (C) 2016 The Qt Company Ltd.</a>
<a name="4"><span class="lineNum">       4 </span>            : ** Contact: https://www.qt.io/licensing/</a>
<a name="5"><span class="lineNum">       5 </span>            : **</a>
<a name="6"><span class="lineNum">       6 </span>            : ** This file is part of the QtWidgets module of the Qt Toolkit.</a>
<a name="7"><span class="lineNum">       7 </span>            : **</a>
<a name="8"><span class="lineNum">       8 </span>            : ** $QT_BEGIN_LICENSE:LGPL$</a>
<a name="9"><span class="lineNum">       9 </span>            : ** Commercial License Usage</a>
<a name="10"><span class="lineNum">      10 </span>            : ** Licensees holding valid commercial Qt licenses may use this file in</a>
<a name="11"><span class="lineNum">      11 </span>            : ** accordance with the commercial license agreement provided with the</a>
<a name="12"><span class="lineNum">      12 </span>            : ** Software or, alternatively, in accordance with the terms contained in</a>
<a name="13"><span class="lineNum">      13 </span>            : ** a written agreement between you and The Qt Company. For licensing terms</a>
<a name="14"><span class="lineNum">      14 </span>            : ** and conditions see https://www.qt.io/terms-conditions. For further</a>
<a name="15"><span class="lineNum">      15 </span>            : ** information use the contact form at https://www.qt.io/contact-us.</a>
<a name="16"><span class="lineNum">      16 </span>            : **</a>
<a name="17"><span class="lineNum">      17 </span>            : ** GNU Lesser General Public License Usage</a>
<a name="18"><span class="lineNum">      18 </span>            : ** Alternatively, this file may be used under the terms of the GNU Lesser</a>
<a name="19"><span class="lineNum">      19 </span>            : ** General Public License version 3 as published by the Free Software</a>
<a name="20"><span class="lineNum">      20 </span>            : ** Foundation and appearing in the file LICENSE.LGPL3 included in the</a>
<a name="21"><span class="lineNum">      21 </span>            : ** packaging of this file. Please review the following information to</a>
<a name="22"><span class="lineNum">      22 </span>            : ** ensure the GNU Lesser General Public License version 3 requirements</a>
<a name="23"><span class="lineNum">      23 </span>            : ** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.</a>
<a name="24"><span class="lineNum">      24 </span>            : **</a>
<a name="25"><span class="lineNum">      25 </span>            : ** GNU General Public License Usage</a>
<a name="26"><span class="lineNum">      26 </span>            : ** Alternatively, this file may be used under the terms of the GNU</a>
<a name="27"><span class="lineNum">      27 </span>            : ** General Public License version 2.0 or (at your option) the GNU General</a>
<a name="28"><span class="lineNum">      28 </span>            : ** Public license version 3 or any later version approved by the KDE Free</a>
<a name="29"><span class="lineNum">      29 </span>            : ** Qt Foundation. The licenses are as published by the Free Software</a>
<a name="30"><span class="lineNum">      30 </span>            : ** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3</a>
<a name="31"><span class="lineNum">      31 </span>            : ** included in the packaging of this file. Please review the following</a>
<a name="32"><span class="lineNum">      32 </span>            : ** information to ensure the GNU General Public License requirements will</a>
<a name="33"><span class="lineNum">      33 </span>            : ** be met: https://www.gnu.org/licenses/gpl-2.0.html and</a>
<a name="34"><span class="lineNum">      34 </span>            : ** https://www.gnu.org/licenses/gpl-3.0.html.</a>
<a name="35"><span class="lineNum">      35 </span>            : **</a>
<a name="36"><span class="lineNum">      36 </span>            : ** $QT_END_LICENSE$</a>
<a name="37"><span class="lineNum">      37 </span>            : **</a>
<a name="38"><span class="lineNum">      38 </span>            : ****************************************************************************/</a>
<a name="39"><span class="lineNum">      39 </span>            : </a>
<a name="40"><span class="lineNum">      40 </span>            : #ifndef QWIDGET_H</a>
<a name="41"><span class="lineNum">      41 </span>            : #define QWIDGET_H</a>
<a name="42"><span class="lineNum">      42 </span>            : </a>
<a name="43"><span class="lineNum">      43 </span>            : #include &lt;QtWidgets/qtwidgetsglobal.h&gt;</a>
<a name="44"><span class="lineNum">      44 </span>            : #include &lt;QtGui/qwindowdefs.h&gt;</a>
<a name="45"><span class="lineNum">      45 </span>            : #include &lt;QtCore/qobject.h&gt;</a>
<a name="46"><span class="lineNum">      46 </span>            : #include &lt;QtCore/qmargins.h&gt;</a>
<a name="47"><span class="lineNum">      47 </span>            : #include &lt;QtGui/qpaintdevice.h&gt;</a>
<a name="48"><span class="lineNum">      48 </span>            : #include &lt;QtGui/qpalette.h&gt;</a>
<a name="49"><span class="lineNum">      49 </span>            : #include &lt;QtGui/qfont.h&gt;</a>
<a name="50"><span class="lineNum">      50 </span>            : #include &lt;QtGui/qfontmetrics.h&gt;</a>
<a name="51"><span class="lineNum">      51 </span>            : #include &lt;QtGui/qfontinfo.h&gt;</a>
<a name="52"><span class="lineNum">      52 </span>            : #include &lt;QtWidgets/qsizepolicy.h&gt;</a>
<a name="53"><span class="lineNum">      53 </span>            : #include &lt;QtGui/qregion.h&gt;</a>
<a name="54"><span class="lineNum">      54 </span>            : #include &lt;QtGui/qbrush.h&gt;</a>
<a name="55"><span class="lineNum">      55 </span>            : #include &lt;QtGui/qcursor.h&gt;</a>
<a name="56"><span class="lineNum">      56 </span>            : #include &lt;QtGui/qkeysequence.h&gt;</a>
<a name="57"><span class="lineNum">      57 </span>            : </a>
<a name="58"><span class="lineNum">      58 </span>            : #ifdef QT_INCLUDE_COMPAT</a>
<a name="59"><span class="lineNum">      59 </span>            : #include &lt;QtGui/qevent.h&gt;</a>
<a name="60"><span class="lineNum">      60 </span>            : #endif</a>
<a name="61"><span class="lineNum">      61 </span>            : </a>
<a name="62"><span class="lineNum">      62 </span>            : QT_BEGIN_NAMESPACE</a>
<a name="63"><span class="lineNum">      63 </span>            : </a>
<a name="64"><span class="lineNum">      64 </span>            : </a>
<a name="65"><span class="lineNum">      65 </span>            : class QLayout;</a>
<a name="66"><span class="lineNum">      66 </span>            : class QWSRegionManager;</a>
<a name="67"><span class="lineNum">      67 </span>            : class QStyle;</a>
<a name="68"><span class="lineNum">      68 </span>            : class QAction;</a>
<a name="69"><span class="lineNum">      69 </span>            : class QVariant;</a>
<a name="70"><span class="lineNum">      70 </span>            : class QWindow;</a>
<a name="71"><span class="lineNum">      71 </span>            : class QActionEvent;</a>
<a name="72"><span class="lineNum">      72 </span>            : class QMouseEvent;</a>
<a name="73"><span class="lineNum">      73 </span>            : class QWheelEvent;</a>
<a name="74"><span class="lineNum">      74 </span>            : class QHoverEvent;</a>
<a name="75"><span class="lineNum">      75 </span>            : class QKeyEvent;</a>
<a name="76"><span class="lineNum">      76 </span>            : class QFocusEvent;</a>
<a name="77"><span class="lineNum">      77 </span>            : class QPaintEvent;</a>
<a name="78"><span class="lineNum">      78 </span>            : class QMoveEvent;</a>
<a name="79"><span class="lineNum">      79 </span>            : class QResizeEvent;</a>
<a name="80"><span class="lineNum">      80 </span>            : class QCloseEvent;</a>
<a name="81"><span class="lineNum">      81 </span>            : class QContextMenuEvent;</a>
<a name="82"><span class="lineNum">      82 </span>            : class QInputMethodEvent;</a>
<a name="83"><span class="lineNum">      83 </span>            : class QTabletEvent;</a>
<a name="84"><span class="lineNum">      84 </span>            : class QDragEnterEvent;</a>
<a name="85"><span class="lineNum">      85 </span>            : class QDragMoveEvent;</a>
<a name="86"><span class="lineNum">      86 </span>            : class QDragLeaveEvent;</a>
<a name="87"><span class="lineNum">      87 </span>            : class QDropEvent;</a>
<a name="88"><span class="lineNum">      88 </span>            : class QScreen;</a>
<a name="89"><span class="lineNum">      89 </span>            : class QShowEvent;</a>
<a name="90"><span class="lineNum">      90 </span>            : class QHideEvent;</a>
<a name="91"><span class="lineNum">      91 </span>            : class QIcon;</a>
<a name="92"><span class="lineNum">      92 </span>            : class QBackingStore;</a>
<a name="93"><span class="lineNum">      93 </span>            : class QPlatformWindow;</a>
<a name="94"><span class="lineNum">      94 </span>            : class QLocale;</a>
<a name="95"><span class="lineNum">      95 </span>            : class QGraphicsProxyWidget;</a>
<a name="96"><span class="lineNum">      96 </span>            : class QGraphicsEffect;</a>
<a name="97"><span class="lineNum">      97 </span>            : class QRasterWindowSurface;</a>
<a name="98"><span class="lineNum">      98 </span>            : class QUnifiedToolbarSurface;</a>
<a name="99"><span class="lineNum">      99 </span>            : class QPixmap;</a>
<a name="100"><span class="lineNum">     100 </span>            : #ifndef QT_NO_DEBUG_STREAM</a>
<a name="101"><span class="lineNum">     101 </span>            : class QDebug;</a>
<a name="102"><span class="lineNum">     102 </span>            : #endif</a>
<a name="103"><span class="lineNum">     103 </span>            : </a>
<a name="104"><span class="lineNum">     104 </span>            : class QWidgetData</a>
<a name="105"><span class="lineNum">     105 </span>            : {</a>
<a name="106"><span class="lineNum">     106 </span>            : public:</a>
<a name="107"><span class="lineNum">     107 </span>            :     WId winid;</a>
<a name="108"><span class="lineNum">     108 </span>            :     uint widget_attributes;</a>
<a name="109"><span class="lineNum">     109 </span>            :     Qt::WindowFlags window_flags;</a>
<a name="110"><span class="lineNum">     110 </span>            :     uint window_state : 4;</a>
<a name="111"><span class="lineNum">     111 </span>            :     uint focus_policy : 4;</a>
<a name="112"><span class="lineNum">     112 </span>            :     uint sizehint_forced :1;</a>
<a name="113"><span class="lineNum">     113 </span>            :     uint is_closing :1;</a>
<a name="114"><span class="lineNum">     114 </span>            :     uint in_show : 1;</a>
<a name="115"><span class="lineNum">     115 </span>            :     uint in_set_window_state : 1;</a>
<a name="116"><span class="lineNum">     116 </span>            :     mutable uint fstrut_dirty : 1;</a>
<a name="117"><span class="lineNum">     117 </span>            :     uint context_menu_policy : 3;</a>
<a name="118"><span class="lineNum">     118 </span>            :     uint window_modality : 2;</a>
<a name="119"><span class="lineNum">     119 </span>            :     uint in_destructor : 1;</a>
<a name="120"><span class="lineNum">     120 </span>            :     uint unused : 13;</a>
<a name="121"><span class="lineNum">     121 </span>            :     QRect crect;</a>
<a name="122"><span class="lineNum">     122 </span>            :     mutable QPalette pal;</a>
<a name="123"><span class="lineNum">     123 </span>            :     QFont fnt;</a>
<a name="124"><span class="lineNum">     124 </span>            :     QRect wrect;</a>
<a name="125"><span class="lineNum">     125 </span>            : };</a>
<a name="126"><span class="lineNum">     126 </span>            : </a>
<a name="127"><span class="lineNum">     127 </span>            : class QWidgetPrivate;</a>
<a name="128"><span class="lineNum">     128 </span>            : </a>
<a name="129"><span class="lineNum">     129 </span>            : class Q_WIDGETS_EXPORT QWidget : public QObject, public QPaintDevice</a>
<a name="130"><span class="lineNum">     130 </span>            : {</a>
<a name="131"><span class="lineNum">     131 </span>            :     Q_OBJECT</a>
<a name="132"><span class="lineNum">     132 </span>            :     Q_DECLARE_PRIVATE(QWidget)</a>
<a name="133"><span class="lineNum">     133 </span>            : </a>
<a name="134"><span class="lineNum">     134 </span>            :     Q_PROPERTY(bool modal READ isModal)</a>
<a name="135"><span class="lineNum">     135 </span>            :     Q_PROPERTY(Qt::WindowModality windowModality READ windowModality WRITE setWindowModality)</a>
<a name="136"><span class="lineNum">     136 </span>            :     Q_PROPERTY(bool enabled READ isEnabled WRITE setEnabled)</a>
<a name="137"><span class="lineNum">     137 </span>            :     Q_PROPERTY(QRect geometry READ geometry WRITE setGeometry)</a>
<a name="138"><span class="lineNum">     138 </span>            :     Q_PROPERTY(QRect frameGeometry READ frameGeometry)</a>
<a name="139"><span class="lineNum">     139 </span>            :     Q_PROPERTY(QRect normalGeometry READ normalGeometry)</a>
<a name="140"><span class="lineNum">     140 </span>            :     Q_PROPERTY(int x READ x)</a>
<a name="141"><span class="lineNum">     141 </span>            :     Q_PROPERTY(int y READ y)</a>
<a name="142"><span class="lineNum">     142 </span>            :     Q_PROPERTY(QPoint pos READ pos WRITE move DESIGNABLE false STORED false)</a>
<a name="143"><span class="lineNum">     143 </span>            :     Q_PROPERTY(QSize frameSize READ frameSize)</a>
<a name="144"><span class="lineNum">     144 </span>            :     Q_PROPERTY(QSize size READ size WRITE resize DESIGNABLE false STORED false)</a>
<a name="145"><span class="lineNum">     145 </span>            :     Q_PROPERTY(int width READ width)</a>
<a name="146"><span class="lineNum">     146 </span>            :     Q_PROPERTY(int height READ height)</a>
<a name="147"><span class="lineNum">     147 </span>            :     Q_PROPERTY(QRect rect READ rect)</a>
<a name="148"><span class="lineNum">     148 </span>            :     Q_PROPERTY(QRect childrenRect READ childrenRect)</a>
<a name="149"><span class="lineNum">     149 </span>            :     Q_PROPERTY(QRegion childrenRegion READ childrenRegion)</a>
<a name="150"><span class="lineNum">     150 </span>            :     Q_PROPERTY(QSizePolicy sizePolicy READ sizePolicy WRITE setSizePolicy)</a>
<a name="151"><span class="lineNum">     151 </span>            :     Q_PROPERTY(QSize minimumSize READ minimumSize WRITE setMinimumSize)</a>
<a name="152"><span class="lineNum">     152 </span>            :     Q_PROPERTY(QSize maximumSize READ maximumSize WRITE setMaximumSize)</a>
<a name="153"><span class="lineNum">     153 </span>            :     Q_PROPERTY(int minimumWidth READ minimumWidth WRITE setMinimumWidth STORED false DESIGNABLE false)</a>
<a name="154"><span class="lineNum">     154 </span>            :     Q_PROPERTY(int minimumHeight READ minimumHeight WRITE setMinimumHeight STORED false DESIGNABLE false)</a>
<a name="155"><span class="lineNum">     155 </span>            :     Q_PROPERTY(int maximumWidth READ maximumWidth WRITE setMaximumWidth STORED false DESIGNABLE false)</a>
<a name="156"><span class="lineNum">     156 </span>            :     Q_PROPERTY(int maximumHeight READ maximumHeight WRITE setMaximumHeight STORED false DESIGNABLE false)</a>
<a name="157"><span class="lineNum">     157 </span>            :     Q_PROPERTY(QSize sizeIncrement READ sizeIncrement WRITE setSizeIncrement)</a>
<a name="158"><span class="lineNum">     158 </span>            :     Q_PROPERTY(QSize baseSize READ baseSize WRITE setBaseSize)</a>
<a name="159"><span class="lineNum">     159 </span>            :     Q_PROPERTY(QPalette palette READ palette WRITE setPalette)</a>
<a name="160"><span class="lineNum">     160 </span>            :     Q_PROPERTY(QFont font READ font WRITE setFont)</a>
<a name="161"><span class="lineNum">     161 </span>            : #ifndef QT_NO_CURSOR</a>
<a name="162"><span class="lineNum">     162 </span>            :     Q_PROPERTY(QCursor cursor READ cursor WRITE setCursor RESET unsetCursor)</a>
<a name="163"><span class="lineNum">     163 </span>            : #endif</a>
<a name="164"><span class="lineNum">     164 </span>            :     Q_PROPERTY(bool mouseTracking READ hasMouseTracking WRITE setMouseTracking)</a>
<a name="165"><span class="lineNum">     165 </span>            :     Q_PROPERTY(bool tabletTracking READ hasTabletTracking WRITE setTabletTracking)</a>
<a name="166"><span class="lineNum">     166 </span>            :     Q_PROPERTY(bool isActiveWindow READ isActiveWindow)</a>
<a name="167"><span class="lineNum">     167 </span>            :     Q_PROPERTY(Qt::FocusPolicy focusPolicy READ focusPolicy WRITE setFocusPolicy)</a>
<a name="168"><span class="lineNum">     168 </span>            :     Q_PROPERTY(bool focus READ hasFocus)</a>
<a name="169"><span class="lineNum">     169 </span>            :     Q_PROPERTY(Qt::ContextMenuPolicy contextMenuPolicy READ contextMenuPolicy WRITE setContextMenuPolicy)</a>
<a name="170"><span class="lineNum">     170 </span>            :     Q_PROPERTY(bool updatesEnabled READ updatesEnabled WRITE setUpdatesEnabled DESIGNABLE false)</a>
<a name="171"><span class="lineNum">     171 </span>            :     Q_PROPERTY(bool visible READ isVisible WRITE setVisible DESIGNABLE false)</a>
<a name="172"><span class="lineNum">     172 </span>            :     Q_PROPERTY(bool minimized READ isMinimized)</a>
<a name="173"><span class="lineNum">     173 </span>            :     Q_PROPERTY(bool maximized READ isMaximized)</a>
<a name="174"><span class="lineNum">     174 </span>            :     Q_PROPERTY(bool fullScreen READ isFullScreen)</a>
<a name="175"><span class="lineNum">     175 </span>            :     Q_PROPERTY(QSize sizeHint READ sizeHint)</a>
<a name="176"><span class="lineNum">     176 </span>            :     Q_PROPERTY(QSize minimumSizeHint READ minimumSizeHint)</a>
<a name="177"><span class="lineNum">     177 </span>            :     Q_PROPERTY(bool acceptDrops READ acceptDrops WRITE setAcceptDrops)</a>
<a name="178"><span class="lineNum">     178 </span>            :     Q_PROPERTY(QString windowTitle READ windowTitle WRITE setWindowTitle NOTIFY windowTitleChanged)</a>
<a name="179"><span class="lineNum">     179 </span>            :     Q_PROPERTY(QIcon windowIcon READ windowIcon WRITE setWindowIcon NOTIFY windowIconChanged)</a>
<a name="180"><span class="lineNum">     180 </span>            :     Q_PROPERTY(QString windowIconText READ windowIconText WRITE setWindowIconText NOTIFY windowIconTextChanged) // deprecated</a>
<a name="181"><span class="lineNum">     181 </span>            :     Q_PROPERTY(double windowOpacity READ windowOpacity WRITE setWindowOpacity)</a>
<a name="182"><span class="lineNum">     182 </span>            :     Q_PROPERTY(bool windowModified READ isWindowModified WRITE setWindowModified)</a>
<a name="183"><span class="lineNum">     183 </span>            : #ifndef QT_NO_TOOLTIP</a>
<a name="184"><span class="lineNum">     184 </span>            :     Q_PROPERTY(QString toolTip READ toolTip WRITE setToolTip)</a>
<a name="185"><span class="lineNum">     185 </span>            :     Q_PROPERTY(int toolTipDuration READ toolTipDuration WRITE setToolTipDuration)</a>
<a name="186"><span class="lineNum">     186 </span>            : #endif</a>
<a name="187"><span class="lineNum">     187 </span>            : #if QT_CONFIG(statustip)</a>
<a name="188"><span class="lineNum">     188 </span>            :     Q_PROPERTY(QString statusTip READ statusTip WRITE setStatusTip)</a>
<a name="189"><span class="lineNum">     189 </span>            : #endif</a>
<a name="190"><span class="lineNum">     190 </span>            : #if QT_CONFIG(whatsthis)</a>
<a name="191"><span class="lineNum">     191 </span>            :     Q_PROPERTY(QString whatsThis READ whatsThis WRITE setWhatsThis)</a>
<a name="192"><span class="lineNum">     192 </span>            : #endif</a>
<a name="193"><span class="lineNum">     193 </span>            : #ifndef QT_NO_ACCESSIBILITY</a>
<a name="194"><span class="lineNum">     194 </span>            :     Q_PROPERTY(QString accessibleName READ accessibleName WRITE setAccessibleName)</a>
<a name="195"><span class="lineNum">     195 </span>            :     Q_PROPERTY(QString accessibleDescription READ accessibleDescription WRITE setAccessibleDescription)</a>
<a name="196"><span class="lineNum">     196 </span>            : #endif</a>
<a name="197"><span class="lineNum">     197 </span>            :     Q_PROPERTY(Qt::LayoutDirection layoutDirection READ layoutDirection WRITE setLayoutDirection RESET unsetLayoutDirection)</a>
<a name="198"><span class="lineNum">     198 </span>            :     QDOC_PROPERTY(Qt::WindowFlags windowFlags READ windowFlags WRITE setWindowFlags)</a>
<a name="199"><span class="lineNum">     199 </span>            :     Q_PROPERTY(bool autoFillBackground READ autoFillBackground WRITE setAutoFillBackground)</a>
<a name="200"><span class="lineNum">     200 </span>            : #ifndef QT_NO_STYLE_STYLESHEET</a>
<a name="201"><span class="lineNum">     201 </span>            :     Q_PROPERTY(QString styleSheet READ styleSheet WRITE setStyleSheet)</a>
<a name="202"><span class="lineNum">     202 </span>            : #endif</a>
<a name="203"><span class="lineNum">     203 </span>            :     Q_PROPERTY(QLocale locale READ locale WRITE setLocale RESET unsetLocale)</a>
<a name="204"><span class="lineNum">     204 </span>            :     Q_PROPERTY(QString windowFilePath READ windowFilePath WRITE setWindowFilePath)</a>
<a name="205"><span class="lineNum">     205 </span>            :     Q_PROPERTY(Qt::InputMethodHints inputMethodHints READ inputMethodHints WRITE setInputMethodHints)</a>
<a name="206"><span class="lineNum">     206 </span>            : </a>
<a name="207"><span class="lineNum">     207 </span>            : public:</a>
<a name="208"><span class="lineNum">     208 </span>            :     enum RenderFlag {</a>
<a name="209"><span class="lineNum">     209 </span>            :         DrawWindowBackground = 0x1,</a>
<a name="210"><span class="lineNum">     210 </span>            :         DrawChildren = 0x2,</a>
<a name="211"><span class="lineNum">     211 </span>            :         IgnoreMask = 0x4</a>
<a name="212"><span class="lineNum">     212 </span>            :     };</a>
<a name="213"><span class="lineNum">     213 </span>            :     Q_DECLARE_FLAGS(RenderFlags, RenderFlag)</a>
<a name="214"><span class="lineNum">     214 </span>            : </a>
<a name="215"><span class="lineNum">     215 </span>            :     explicit QWidget(QWidget* parent = nullptr, Qt::WindowFlags f = Qt::WindowFlags());</a>
<a name="216"><span class="lineNum">     216 </span>            :     ~QWidget();</a>
<a name="217"><span class="lineNum">     217 </span>            : </a>
<a name="218"><span class="lineNum">     218 </span>            :     int devType() const override;</a>
<a name="219"><span class="lineNum">     219 </span>            : </a>
<a name="220"><span class="lineNum">     220 </span>            :     WId winId() const;</a>
<a name="221"><span class="lineNum">     221 </span>            :     void createWinId(); // internal, going away</a>
<a name="222"><span class="lineNum">     222 </span>            :     inline WId internalWinId() const { return data-&gt;winid; }</a>
<a name="223"><span class="lineNum">     223 </span>            :     WId effectiveWinId() const;</a>
<a name="224"><span class="lineNum">     224 </span>            : </a>
<a name="225"><span class="lineNum">     225 </span>            :     // GUI style setting</a>
<a name="226"><span class="lineNum">     226 </span>            :     QStyle *style() const;</a>
<a name="227"><span class="lineNum">     227 </span>            :     void setStyle(QStyle *);</a>
<a name="228"><span class="lineNum">     228 </span>            :     // Widget types and states</a>
<a name="229"><span class="lineNum">     229 </span>            : </a>
<a name="230"><span class="lineNum">     230 </span>            :     bool isTopLevel() const;</a>
<a name="231"><span class="lineNum">     231 </span>            :     bool isWindow() const;</a>
<a name="232"><span class="lineNum">     232 </span>            : </a>
<a name="233"><span class="lineNum">     233 </span>            :     bool isModal() const;</a>
<a name="234"><span class="lineNum">     234 </span>            :     Qt::WindowModality windowModality() const;</a>
<a name="235"><span class="lineNum">     235 </span>            :     void setWindowModality(Qt::WindowModality windowModality);</a>
<a name="236"><span class="lineNum">     236 </span>            : </a>
<a name="237"><span class="lineNum">     237 </span>            :     bool isEnabled() const;</a>
<a name="238"><span class="lineNum">     238 </span>            :     bool isEnabledTo(const QWidget *) const;</a>
<a name="239"><span class="lineNum">     239 </span>            : #if QT_DEPRECATED_SINCE(5, 13)</a>
<a name="240"><span class="lineNum">     240 </span>            :     QT_DEPRECATED_X (&quot;Use isEnabled() instead&quot;)</a>
<a name="241"><span class="lineNum">     241 </span>            :     bool isEnabledToTLW() const;</a>
<a name="242"><span class="lineNum">     242 </span>            : #endif</a>
<a name="243"><span class="lineNum">     243 </span>            : </a>
<a name="244"><span class="lineNum">     244 </span>            : public Q_SLOTS:</a>
<a name="245"><span class="lineNum">     245 </span>            :     void setEnabled(bool);</a>
<a name="246"><span class="lineNum">     246 </span>            :     void setDisabled(bool);</a>
<a name="247"><span class="lineNum">     247 </span>            :     void setWindowModified(bool);</a>
<a name="248"><span class="lineNum">     248 </span>            : </a>
<a name="249"><span class="lineNum">     249 </span>            :     // Widget coordinates</a>
<a name="250"><span class="lineNum">     250 </span>            : </a>
<a name="251"><span class="lineNum">     251 </span>            : public:</a>
<a name="252"><span class="lineNum">     252 </span>            :     QRect frameGeometry() const;</a>
<a name="253"><span class="lineNum">     253 </span>            :     const QRect &amp;geometry() const;</a>
<a name="254"><span class="lineNum">     254 </span>            :     QRect normalGeometry() const;</a>
<a name="255"><span class="lineNum">     255 </span>            : </a>
<a name="256"><span class="lineNum">     256 </span>            :     int x() const;</a>
<a name="257"><span class="lineNum">     257 </span>            :     int y() const;</a>
<a name="258"><span class="lineNum">     258 </span>            :     QPoint pos() const;</a>
<a name="259"><span class="lineNum">     259 </span>            :     QSize frameSize() const;</a>
<a name="260"><span class="lineNum">     260 </span>            :     QSize size() const;</a>
<a name="261"><span class="lineNum">     261 </span>            :     inline int width() const;</a>
<a name="262"><span class="lineNum">     262 </span>            :     inline int height() const;</a>
<a name="263"><span class="lineNum">     263 </span>            :     inline QRect rect() const;</a>
<a name="264"><span class="lineNum">     264 </span>            :     QRect childrenRect() const;</a>
<a name="265"><span class="lineNum">     265 </span>            :     QRegion childrenRegion() const;</a>
<a name="266"><span class="lineNum">     266 </span>            : </a>
<a name="267"><span class="lineNum">     267 </span>            :     QSize minimumSize() const;</a>
<a name="268"><span class="lineNum">     268 </span>            :     QSize maximumSize() const;</a>
<a name="269"><span class="lineNum">     269 </span>            :     int minimumWidth() const;</a>
<a name="270"><span class="lineNum">     270 </span>            :     int minimumHeight() const;</a>
<a name="271"><span class="lineNum">     271 </span>            :     int maximumWidth() const;</a>
<a name="272"><span class="lineNum">     272 </span>            :     int maximumHeight() const;</a>
<a name="273"><span class="lineNum">     273 </span>            :     void setMinimumSize(const QSize &amp;);</a>
<a name="274"><span class="lineNum">     274 </span>            :     void setMinimumSize(int minw, int minh);</a>
<a name="275"><span class="lineNum">     275 </span>            :     void setMaximumSize(const QSize &amp;);</a>
<a name="276"><span class="lineNum">     276 </span>            :     void setMaximumSize(int maxw, int maxh);</a>
<a name="277"><span class="lineNum">     277 </span>            :     void setMinimumWidth(int minw);</a>
<a name="278"><span class="lineNum">     278 </span>            :     void setMinimumHeight(int minh);</a>
<a name="279"><span class="lineNum">     279 </span>            :     void setMaximumWidth(int maxw);</a>
<a name="280"><span class="lineNum">     280 </span>            :     void setMaximumHeight(int maxh);</a>
<a name="281"><span class="lineNum">     281 </span>            : </a>
<a name="282"><span class="lineNum">     282 </span>            : #ifdef Q_QDOC</a>
<a name="283"><span class="lineNum">     283 </span>            :     void setupUi(QWidget *widget);</a>
<a name="284"><span class="lineNum">     284 </span>            : #endif</a>
<a name="285"><span class="lineNum">     285 </span>            : </a>
<a name="286"><span class="lineNum">     286 </span>            :     QSize sizeIncrement() const;</a>
<a name="287"><span class="lineNum">     287 </span>            :     void setSizeIncrement(const QSize &amp;);</a>
<a name="288"><span class="lineNum">     288 </span>            :     void setSizeIncrement(int w, int h);</a>
<a name="289"><span class="lineNum">     289 </span>            :     QSize baseSize() const;</a>
<a name="290"><span class="lineNum">     290 </span>            :     void setBaseSize(const QSize &amp;);</a>
<a name="291"><span class="lineNum">     291 </span>            :     void setBaseSize(int basew, int baseh);</a>
<a name="292"><span class="lineNum">     292 </span>            : </a>
<a name="293"><span class="lineNum">     293 </span>            :     void setFixedSize(const QSize &amp;);</a>
<a name="294"><span class="lineNum">     294 </span>            :     void setFixedSize(int w, int h);</a>
<a name="295"><span class="lineNum">     295 </span>            :     void setFixedWidth(int w);</a>
<a name="296"><span class="lineNum">     296 </span>            :     void setFixedHeight(int h);</a>
<a name="297"><span class="lineNum">     297 </span>            : </a>
<a name="298"><span class="lineNum">     298 </span>            :     // Widget coordinate mapping</a>
<a name="299"><span class="lineNum">     299 </span>            : </a>
<a name="300"><span class="lineNum">     300 </span>            :     QPoint mapToGlobal(const QPoint &amp;) const;</a>
<a name="301"><span class="lineNum">     301 </span>            :     QPoint mapFromGlobal(const QPoint &amp;) const;</a>
<a name="302"><span class="lineNum">     302 </span>            :     QPoint mapToParent(const QPoint &amp;) const;</a>
<a name="303"><span class="lineNum">     303 </span>            :     QPoint mapFromParent(const QPoint &amp;) const;</a>
<a name="304"><span class="lineNum">     304 </span>            :     QPoint mapTo(const QWidget *, const QPoint &amp;) const;</a>
<a name="305"><span class="lineNum">     305 </span>            :     QPoint mapFrom(const QWidget *, const QPoint &amp;) const;</a>
<a name="306"><span class="lineNum">     306 </span>            : </a>
<a name="307"><span class="lineNum">     307 </span>            :     QWidget *window() const;</a>
<a name="308"><span class="lineNum">     308 </span>            :     QWidget *nativeParentWidget() const;</a>
<a name="309"><span class="lineNum">     309 </span>            :     inline QWidget *topLevelWidget() const { return window(); }</a>
<a name="310"><span class="lineNum">     310 </span>            : </a>
<a name="311"><span class="lineNum">     311 </span>            :     // Widget appearance functions</a>
<a name="312"><span class="lineNum">     312 </span>            :     const QPalette &amp;palette() const;</a>
<a name="313"><span class="lineNum">     313 </span>            :     void setPalette(const QPalette &amp;);</a>
<a name="314"><span class="lineNum">     314 </span>            : </a>
<a name="315"><span class="lineNum">     315 </span>            :     void setBackgroundRole(QPalette::ColorRole);</a>
<a name="316"><span class="lineNum">     316 </span>            :     QPalette::ColorRole backgroundRole() const;</a>
<a name="317"><span class="lineNum">     317 </span>            : </a>
<a name="318"><span class="lineNum">     318 </span>            :     void setForegroundRole(QPalette::ColorRole);</a>
<a name="319"><span class="lineNum">     319 </span>            :     QPalette::ColorRole foregroundRole() const;</a>
<a name="320"><span class="lineNum">     320 </span>            : </a>
<a name="321"><span class="lineNum">     321 </span>            :     const QFont &amp;font() const;</a>
<a name="322"><span class="lineNum">     322 </span>            :     void setFont(const QFont &amp;);</a>
<a name="323"><span class="lineNum">     323 </span>            :     QFontMetrics fontMetrics() const;</a>
<a name="324"><span class="lineNum">     324 </span>            :     QFontInfo fontInfo() const;</a>
<a name="325"><span class="lineNum">     325 </span>            : </a>
<a name="326"><span class="lineNum">     326 </span>            : #ifndef QT_NO_CURSOR</a>
<a name="327"><span class="lineNum">     327 </span>            :     QCursor cursor() const;</a>
<a name="328"><span class="lineNum">     328 </span>            :     void setCursor(const QCursor &amp;);</a>
<a name="329"><span class="lineNum">     329 </span>            :     void unsetCursor();</a>
<a name="330"><span class="lineNum">     330 </span>            : #endif</a>
<a name="331"><span class="lineNum">     331 </span>            : </a>
<a name="332"><span class="lineNum">     332 </span>            :     void setMouseTracking(bool enable);</a>
<a name="333"><span class="lineNum">     333 </span>            :     bool hasMouseTracking() const;</a>
<a name="334"><span class="lineNum">     334 </span>            :     bool underMouse() const;</a>
<a name="335"><span class="lineNum">     335 </span>            : </a>
<a name="336"><span class="lineNum">     336 </span>            :     void setTabletTracking(bool enable);</a>
<a name="337"><span class="lineNum">     337 </span>            :     bool hasTabletTracking() const;</a>
<a name="338"><span class="lineNum">     338 </span>            : </a>
<a name="339"><span class="lineNum">     339 </span>            :     void setMask(const QBitmap &amp;);</a>
<a name="340"><span class="lineNum">     340 </span>            :     void setMask(const QRegion &amp;);</a>
<a name="341"><span class="lineNum">     341 </span>            :     QRegion mask() const;</a>
<a name="342"><span class="lineNum">     342 </span>            :     void clearMask();</a>
<a name="343"><span class="lineNum">     343 </span>            : </a>
<a name="344"><span class="lineNum">     344 </span>            :     void render(QPaintDevice *target, const QPoint &amp;targetOffset = QPoint(),</a>
<a name="345"><span class="lineNum">     345 </span>            :                 const QRegion &amp;sourceRegion = QRegion(),</a>
<a name="346"><span class="lineNum">     346 </span>            :                 RenderFlags renderFlags = RenderFlags(DrawWindowBackground | DrawChildren));</a>
<a name="347"><span class="lineNum">     347 </span>            : </a>
<a name="348"><span class="lineNum">     348 </span>            :     void render(QPainter *painter, const QPoint &amp;targetOffset = QPoint(),</a>
<a name="349"><span class="lineNum">     349 </span>            :                 const QRegion &amp;sourceRegion = QRegion(),</a>
<a name="350"><span class="lineNum">     350 </span>            :                 RenderFlags renderFlags = RenderFlags(DrawWindowBackground | DrawChildren));</a>
<a name="351"><span class="lineNum">     351 </span>            : </a>
<a name="352"><span class="lineNum">     352 </span>            :     Q_INVOKABLE QPixmap grab(const QRect &amp;rectangle = QRect(QPoint(0, 0), QSize(-1, -1)));</a>
<a name="353"><span class="lineNum">     353 </span>            : </a>
<a name="354"><span class="lineNum">     354 </span>            : #if QT_CONFIG(graphicseffect)</a>
<a name="355"><span class="lineNum">     355 </span>            :     QGraphicsEffect *graphicsEffect() const;</a>
<a name="356"><span class="lineNum">     356 </span>            :     void setGraphicsEffect(QGraphicsEffect *effect);</a>
<a name="357"><span class="lineNum">     357 </span>            : #endif // QT_CONFIG(graphicseffect)</a>
<a name="358"><span class="lineNum">     358 </span>            : </a>
<a name="359"><span class="lineNum">     359 </span>            : #ifndef QT_NO_GESTURES</a>
<a name="360"><span class="lineNum">     360 </span>            :     void grabGesture(Qt::GestureType type, Qt::GestureFlags flags = Qt::GestureFlags());</a>
<a name="361"><span class="lineNum">     361 </span>            :     void ungrabGesture(Qt::GestureType type);</a>
<a name="362"><span class="lineNum">     362 </span>            : #endif</a>
<a name="363"><span class="lineNum">     363 </span>            : </a>
<a name="364"><span class="lineNum">     364 </span>            : public Q_SLOTS:</a>
<a name="365"><span class="lineNum">     365 </span>            :     void setWindowTitle(const QString &amp;);</a>
<a name="366"><span class="lineNum">     366 </span>            : #ifndef QT_NO_STYLE_STYLESHEET</a>
<a name="367"><span class="lineNum">     367 </span>            :     void setStyleSheet(const QString&amp; styleSheet);</a>
<a name="368"><span class="lineNum">     368 </span>            : #endif</a>
<a name="369"><span class="lineNum">     369 </span>            : public:</a>
<a name="370"><span class="lineNum">     370 </span>            : #ifndef QT_NO_STYLE_STYLESHEET</a>
<a name="371"><span class="lineNum">     371 </span>            :     QString styleSheet() const;</a>
<a name="372"><span class="lineNum">     372 </span>            : #endif</a>
<a name="373"><span class="lineNum">     373 </span>            :     QString windowTitle() const;</a>
<a name="374"><span class="lineNum">     374 </span>            :     void setWindowIcon(const QIcon &amp;icon);</a>
<a name="375"><span class="lineNum">     375 </span>            :     QIcon windowIcon() const;</a>
<a name="376"><span class="lineNum">     376 </span>            :     void setWindowIconText(const QString &amp;);</a>
<a name="377"><span class="lineNum">     377 </span>            :     QString windowIconText() const;</a>
<a name="378"><span class="lineNum">     378 </span>            :     void setWindowRole(const QString &amp;);</a>
<a name="379"><span class="lineNum">     379 </span>            :     QString windowRole() const;</a>
<a name="380"><span class="lineNum">     380 </span>            :     void setWindowFilePath(const QString &amp;filePath);</a>
<a name="381"><span class="lineNum">     381 </span>            :     QString windowFilePath() const;</a>
<a name="382"><span class="lineNum">     382 </span>            : </a>
<a name="383"><span class="lineNum">     383 </span>            :     void setWindowOpacity(qreal level);</a>
<a name="384"><span class="lineNum">     384 </span>            :     qreal windowOpacity() const;</a>
<a name="385"><span class="lineNum">     385 </span>            : </a>
<a name="386"><span class="lineNum">     386 </span>            :     bool isWindowModified() const;</a>
<a name="387"><span class="lineNum">     387 </span>            : #ifndef QT_NO_TOOLTIP</a>
<a name="388"><span class="lineNum">     388 </span>            :     void setToolTip(const QString &amp;);</a>
<a name="389"><span class="lineNum">     389 </span>            :     QString toolTip() const;</a>
<a name="390"><span class="lineNum">     390 </span>            :     void setToolTipDuration(int msec);</a>
<a name="391"><span class="lineNum">     391 </span>            :     int toolTipDuration() const;</a>
<a name="392"><span class="lineNum">     392 </span>            : #endif</a>
<a name="393"><span class="lineNum">     393 </span>            : #if QT_CONFIG(statustip)</a>
<a name="394"><span class="lineNum">     394 </span>            :     void setStatusTip(const QString &amp;);</a>
<a name="395"><span class="lineNum">     395 </span>            :     QString statusTip() const;</a>
<a name="396"><span class="lineNum">     396 </span>            : #endif</a>
<a name="397"><span class="lineNum">     397 </span>            : #if QT_CONFIG(whatsthis)</a>
<a name="398"><span class="lineNum">     398 </span>            :     void setWhatsThis(const QString &amp;);</a>
<a name="399"><span class="lineNum">     399 </span>            :     QString whatsThis() const;</a>
<a name="400"><span class="lineNum">     400 </span>            : #endif</a>
<a name="401"><span class="lineNum">     401 </span>            : #ifndef QT_NO_ACCESSIBILITY</a>
<a name="402"><span class="lineNum">     402 </span>            :     QString accessibleName() const;</a>
<a name="403"><span class="lineNum">     403 </span>            :     void setAccessibleName(const QString &amp;name);</a>
<a name="404"><span class="lineNum">     404 </span>            :     QString accessibleDescription() const;</a>
<a name="405"><span class="lineNum">     405 </span>            :     void setAccessibleDescription(const QString &amp;description);</a>
<a name="406"><span class="lineNum">     406 </span>            : #endif</a>
<a name="407"><span class="lineNum">     407 </span>            : </a>
<a name="408"><span class="lineNum">     408 </span>            :     void setLayoutDirection(Qt::LayoutDirection direction);</a>
<a name="409"><span class="lineNum">     409 </span>            :     Qt::LayoutDirection layoutDirection() const;</a>
<a name="410"><span class="lineNum">     410 </span>            :     void unsetLayoutDirection();</a>
<a name="411"><span class="lineNum">     411 </span>            : </a>
<a name="412"><span class="lineNum">     412 </span>            :     void setLocale(const QLocale &amp;locale);</a>
<a name="413"><span class="lineNum">     413 </span>            :     QLocale locale() const;</a>
<a name="414"><span class="lineNum">     414 </span>            :     void unsetLocale();</a>
<a name="415"><span class="lineNum">     415 </span>            : </a>
<a name="416"><span class="lineNum">     416 </span>            :     inline bool isRightToLeft() const { return layoutDirection() == Qt::RightToLeft; }</a>
<a name="417"><span class="lineNum">     417 </span>            :     inline bool isLeftToRight() const { return layoutDirection() == Qt::LeftToRight; }</a>
<a name="418"><span class="lineNum">     418 </span>            : </a>
<a name="419"><span class="lineNum">     419 </span>            : public Q_SLOTS:</a>
<a name="420"><span class="lineNum">     420 </span>            :     inline void setFocus() { setFocus(Qt::OtherFocusReason); }</a>
<a name="421"><span class="lineNum">     421 </span>            : </a>
<a name="422"><span class="lineNum">     422 </span>            : public:</a>
<a name="423"><span class="lineNum">     423 </span>            :     bool isActiveWindow() const;</a>
<a name="424"><span class="lineNum">     424 </span>            :     void activateWindow();</a>
<a name="425"><span class="lineNum">     425 </span>            :     void clearFocus();</a>
<a name="426"><span class="lineNum">     426 </span>            : </a>
<a name="427"><span class="lineNum">     427 </span>            :     void setFocus(Qt::FocusReason reason);</a>
<a name="428"><span class="lineNum">     428 </span>            :     Qt::FocusPolicy focusPolicy() const;</a>
<a name="429"><span class="lineNum">     429 </span>            :     void setFocusPolicy(Qt::FocusPolicy policy);</a>
<a name="430"><span class="lineNum">     430 </span>            :     bool hasFocus() const;</a>
<a name="431"><span class="lineNum">     431 </span>            :     static void setTabOrder(QWidget *, QWidget *);</a>
<a name="432"><span class="lineNum">     432 </span>            :     void setFocusProxy(QWidget *);</a>
<a name="433"><span class="lineNum">     433 </span>            :     QWidget *focusProxy() const;</a>
<a name="434"><span class="lineNum">     434 </span>            :     Qt::ContextMenuPolicy contextMenuPolicy() const;</a>
<a name="435"><span class="lineNum">     435 </span>            :     void setContextMenuPolicy(Qt::ContextMenuPolicy policy);</a>
<a name="436"><span class="lineNum">     436 </span>            : </a>
<a name="437"><span class="lineNum">     437 </span>            :     // Grab functions</a>
<a name="438"><span class="lineNum">     438 </span>            :     void grabMouse();</a>
<a name="439"><span class="lineNum">     439 </span>            : #ifndef QT_NO_CURSOR</a>
<a name="440"><span class="lineNum">     440 </span>            :     void grabMouse(const QCursor &amp;);</a>
<a name="441"><span class="lineNum">     441 </span>            : #endif</a>
<a name="442"><span class="lineNum">     442 </span>            :     void releaseMouse();</a>
<a name="443"><span class="lineNum">     443 </span>            :     void grabKeyboard();</a>
<a name="444"><span class="lineNum">     444 </span>            :     void releaseKeyboard();</a>
<a name="445"><span class="lineNum">     445 </span>            : #ifndef QT_NO_SHORTCUT</a>
<a name="446"><span class="lineNum">     446 </span>            :     int grabShortcut(const QKeySequence &amp;key, Qt::ShortcutContext context = Qt::WindowShortcut);</a>
<a name="447"><span class="lineNum">     447 </span>            :     void releaseShortcut(int id);</a>
<a name="448"><span class="lineNum">     448 </span>            :     void setShortcutEnabled(int id, bool enable = true);</a>
<a name="449"><span class="lineNum">     449 </span>            :     void setShortcutAutoRepeat(int id, bool enable = true);</a>
<a name="450"><span class="lineNum">     450 </span>            : #endif</a>
<a name="451"><span class="lineNum">     451 </span>            :     static QWidget *mouseGrabber();</a>
<a name="452"><span class="lineNum">     452 </span>            :     static QWidget *keyboardGrabber();</a>
<a name="453"><span class="lineNum">     453 </span>            : </a>
<a name="454"><span class="lineNum">     454 </span>            :     // Update/refresh functions</a>
<a name="455"><span class="lineNum">     455 </span>            :     inline bool updatesEnabled() const;</a>
<a name="456"><span class="lineNum">     456 </span>            :     void setUpdatesEnabled(bool enable);</a>
<a name="457"><span class="lineNum">     457 </span>            : </a>
<a name="458"><span class="lineNum">     458 </span>            : #if QT_CONFIG(graphicsview)</a>
<a name="459"><span class="lineNum">     459 </span>            :     QGraphicsProxyWidget *graphicsProxyWidget() const;</a>
<a name="460"><span class="lineNum">     460 </span>            : #endif</a>
<a name="461"><span class="lineNum">     461 </span>            : </a>
<a name="462"><span class="lineNum">     462 </span>            : public Q_SLOTS:</a>
<a name="463"><span class="lineNum">     463 </span>            :     void update();</a>
<a name="464"><span class="lineNum">     464 </span>            :     void repaint();</a>
<a name="465"><span class="lineNum">     465 </span>            : </a>
<a name="466"><span class="lineNum">     466 </span>            : public:</a>
<a name="467"><span class="lineNum">     467 </span>            :     inline void update(int x, int y, int w, int h);</a>
<a name="468"><span class="lineNum">     468 </span>            :     void update(const QRect&amp;);</a>
<a name="469"><span class="lineNum">     469 </span>            :     void update(const QRegion&amp;);</a>
<a name="470"><span class="lineNum">     470 </span>            : </a>
<a name="471"><span class="lineNum">     471 </span>            :     void repaint(int x, int y, int w, int h);</a>
<a name="472"><span class="lineNum">     472 </span>            :     void repaint(const QRect &amp;);</a>
<a name="473"><span class="lineNum">     473 </span>            :     void repaint(const QRegion &amp;);</a>
<a name="474"><span class="lineNum">     474 </span>            : </a>
<a name="475"><span class="lineNum">     475 </span>            : public Q_SLOTS:</a>
<a name="476"><span class="lineNum">     476 </span>            :     // Widget management functions</a>
<a name="477"><span class="lineNum">     477 </span>            : </a>
<a name="478"><span class="lineNum">     478 </span>            :     virtual void setVisible(bool visible);</a>
<a name="479"><span class="lineNum">     479 </span>            :     void setHidden(bool hidden);</a>
<a name="480"><span class="lineNum">     480 </span>            :     void show();</a>
<a name="481"><span class="lineNum">     481 </span>            :     void hide();</a>
<a name="482"><span class="lineNum">     482 </span>            : </a>
<a name="483"><span class="lineNum">     483 </span>            :     void showMinimized();</a>
<a name="484"><span class="lineNum">     484 </span>            :     void showMaximized();</a>
<a name="485"><span class="lineNum">     485 </span>            :     void showFullScreen();</a>
<a name="486"><span class="lineNum">     486 </span>            :     void showNormal();</a>
<a name="487"><span class="lineNum">     487 </span>            : </a>
<a name="488"><span class="lineNum">     488 </span>            :     bool close();</a>
<a name="489"><span class="lineNum">     489 </span>            :     void raise();</a>
<a name="490"><span class="lineNum">     490 </span>            :     void lower();</a>
<a name="491"><span class="lineNum">     491 </span>            : </a>
<a name="492"><span class="lineNum">     492 </span>            : public:</a>
<a name="493"><span class="lineNum">     493 </span>            :     void stackUnder(QWidget*);</a>
<a name="494"><span class="lineNum">     494 </span>            :     void move(int x, int y);</a>
<a name="495"><span class="lineNum">     495 </span>            :     void move(const QPoint &amp;);</a>
<a name="496"><span class="lineNum">     496 </span>            :     void resize(int w, int h);</a>
<a name="497"><span class="lineNum">     497 </span>            :     void resize(const QSize &amp;);</a>
<a name="498"><span class="lineNum">     498 </span>            :     inline void setGeometry(int x, int y, int w, int h);</a>
<a name="499"><span class="lineNum">     499 </span>            :     void setGeometry(const QRect &amp;);</a>
<a name="500"><span class="lineNum">     500 </span>            :     QByteArray saveGeometry() const;</a>
<a name="501"><span class="lineNum">     501 </span>            :     bool restoreGeometry(const QByteArray &amp;geometry);</a>
<a name="502"><span class="lineNum">     502 </span>            :     void adjustSize();</a>
<a name="503"><span class="lineNum">     503 </span>            :     bool isVisible() const;</a>
<a name="504"><span class="lineNum">     504 </span>            :     bool isVisibleTo(const QWidget *) const;</a>
<a name="505"><span class="lineNum">     505 </span>            :     inline bool isHidden() const;</a>
<a name="506"><span class="lineNum">     506 </span>            : </a>
<a name="507"><span class="lineNum">     507 </span>            :     bool isMinimized() const;</a>
<a name="508"><span class="lineNum">     508 </span>            :     bool isMaximized() const;</a>
<a name="509"><span class="lineNum">     509 </span>            :     bool isFullScreen() const;</a>
<a name="510"><span class="lineNum">     510 </span>            : </a>
<a name="511"><span class="lineNum">     511 </span>            :     Qt::WindowStates windowState() const;</a>
<a name="512"><span class="lineNum">     512 </span>            :     void setWindowState(Qt::WindowStates state);</a>
<a name="513"><span class="lineNum">     513 </span>            :     void overrideWindowState(Qt::WindowStates state);</a>
<a name="514"><span class="lineNum">     514 </span>            : </a>
<a name="515"><span class="lineNum">     515 </span>            :     virtual QSize sizeHint() const;</a>
<a name="516"><span class="lineNum">     516 </span>            :     virtual QSize minimumSizeHint() const;</a>
<a name="517"><span class="lineNum">     517 </span>            : </a>
<a name="518"><span class="lineNum">     518 </span>            :     QSizePolicy sizePolicy() const;</a>
<a name="519"><span class="lineNum">     519 </span>            :     void setSizePolicy(QSizePolicy);</a>
<a name="520"><span class="lineNum">     520 </span>            :     inline void setSizePolicy(QSizePolicy::Policy horizontal, QSizePolicy::Policy vertical);</a>
<a name="521"><span class="lineNum">     521 </span>            :     virtual int heightForWidth(int) const;</a>
<a name="522"><span class="lineNum">     522 </span>            :     virtual bool hasHeightForWidth() const;</a>
<a name="523"><span class="lineNum">     523 </span>            : </a>
<a name="524"><span class="lineNum">     524 </span>            :     QRegion visibleRegion() const;</a>
<a name="525"><span class="lineNum">     525 </span>            : </a>
<a name="526"><span class="lineNum">     526 </span>            :     void setContentsMargins(int left, int top, int right, int bottom);</a>
<a name="527"><span class="lineNum">     527 </span>            :     void setContentsMargins(const QMargins &amp;margins);</a>
<a name="528"><span class="lineNum">     528 </span>            : #if QT_DEPRECATED_SINCE(5, 14)</a>
<a name="529"><span class="lineNum">     529 </span>            :     QT_DEPRECATED_X(&quot;use contentsMargins()&quot;)</a>
<a name="530"><span class="lineNum">     530 </span>            :     void getContentsMargins(int *left, int *top, int *right, int *bottom) const;</a>
<a name="531"><span class="lineNum">     531 </span>            : #endif</a>
<a name="532"><span class="lineNum">     532 </span>            :     QMargins contentsMargins() const;</a>
<a name="533"><span class="lineNum">     533 </span>            : </a>
<a name="534"><span class="lineNum">     534 </span>            :     QRect contentsRect() const;</a>
<a name="535"><span class="lineNum">     535 </span>            : </a>
<a name="536"><span class="lineNum">     536 </span>            : public:</a>
<a name="537"><span class="lineNum">     537 </span>            :     QLayout *layout() const;</a>
<a name="538"><span class="lineNum">     538 </span>            :     void setLayout(QLayout *);</a>
<a name="539"><span class="lineNum">     539 </span>            :     void updateGeometry();</a>
<a name="540"><span class="lineNum">     540 </span>            : </a>
<a name="541"><span class="lineNum">     541 </span>            :     void setParent(QWidget *parent);</a>
<a name="542"><span class="lineNum">     542 </span>            :     void setParent(QWidget *parent, Qt::WindowFlags f);</a>
<a name="543"><span class="lineNum">     543 </span>            : </a>
<a name="544"><span class="lineNum">     544 </span>            :     void scroll(int dx, int dy);</a>
<a name="545"><span class="lineNum">     545 </span>            :     void scroll(int dx, int dy, const QRect&amp;);</a>
<a name="546"><span class="lineNum">     546 </span>            : </a>
<a name="547"><span class="lineNum">     547 </span>            :     // Misc. functions</a>
<a name="548"><span class="lineNum">     548 </span>            : </a>
<a name="549"><span class="lineNum">     549 </span>            :     QWidget *focusWidget() const;</a>
<a name="550"><span class="lineNum">     550 </span>            :     QWidget *nextInFocusChain() const;</a>
<a name="551"><span class="lineNum">     551 </span>            :     QWidget *previousInFocusChain() const;</a>
<a name="552"><span class="lineNum">     552 </span>            : </a>
<a name="553"><span class="lineNum">     553 </span>            :     // drag and drop</a>
<a name="554"><span class="lineNum">     554 </span>            :     bool acceptDrops() const;</a>
<a name="555"><span class="lineNum">     555 </span>            :     void setAcceptDrops(bool on);</a>
<a name="556"><span class="lineNum">     556 </span>            : </a>
<a name="557"><span class="lineNum">     557 </span>            : #ifndef QT_NO_ACTION</a>
<a name="558"><span class="lineNum">     558 </span>            :     //actions</a>
<a name="559"><span class="lineNum">     559 </span>            :     void addAction(QAction *action);</a>
<a name="560"><span class="lineNum">     560 </span>            : #if QT_VERSION &gt;= QT_VERSION_CHECK(6,0,0)</a>
<a name="561"><span class="lineNum">     561 </span>            :     void addActions(const QList&lt;QAction*&gt; &amp;actions);</a>
<a name="562"><span class="lineNum">     562 </span>            :     void insertActions(QAction *before, const QList&lt;QAction*&gt; &amp;actions);</a>
<a name="563"><span class="lineNum">     563 </span>            : #else</a>
<a name="564"><span class="lineNum">     564 </span>            :     void addActions(QList&lt;QAction*&gt; actions);</a>
<a name="565"><span class="lineNum">     565 </span>            :     void insertActions(QAction *before, QList&lt;QAction*&gt; actions);</a>
<a name="566"><span class="lineNum">     566 </span>            : #endif</a>
<a name="567"><span class="lineNum">     567 </span>            :     void insertAction(QAction *before, QAction *action);</a>
<a name="568"><span class="lineNum">     568 </span>            :     void removeAction(QAction *action);</a>
<a name="569"><span class="lineNum">     569 </span>            :     QList&lt;QAction*&gt; actions() const;</a>
<a name="570"><span class="lineNum">     570 </span>            : #endif</a>
<a name="571"><span class="lineNum">     571 </span>            : </a>
<a name="572"><span class="lineNum">     572 </span>            :     QWidget *parentWidget() const;</a>
<a name="573"><span class="lineNum">     573 </span>            : </a>
<a name="574"><span class="lineNum">     574 </span>            :     void setWindowFlags(Qt::WindowFlags type);</a>
<a name="575"><span class="lineNum">     575 </span>            :     inline Qt::WindowFlags windowFlags() const;</a>
<a name="576"><span class="lineNum">     576 </span>            :     void setWindowFlag(Qt::WindowType, bool on = true);</a>
<a name="577"><span class="lineNum">     577 </span>            :     void overrideWindowFlags(Qt::WindowFlags type);</a>
<a name="578"><span class="lineNum">     578 </span>            : </a>
<a name="579"><span class="lineNum">     579 </span>            :     inline Qt::WindowType windowType() const;</a>
<a name="580"><span class="lineNum">     580 </span>            : </a>
<a name="581"><span class="lineNum">     581 </span>            :     static QWidget *find(WId);</a>
<a name="582"><span class="lineNum">     582 </span>            :     inline QWidget *childAt(int x, int y) const;</a>
<a name="583"><span class="lineNum">     583 </span>            :     QWidget *childAt(const QPoint &amp;p) const;</a>
<a name="584"><span class="lineNum">     584 </span>            : </a>
<a name="585"><span class="lineNum">     585 </span>            :     void setAttribute(Qt::WidgetAttribute, bool on = true);</a>
<a name="586"><span class="lineNum">     586 </span>            :     inline bool testAttribute(Qt::WidgetAttribute) const;</a>
<a name="587"><span class="lineNum">     587 </span>            : </a>
<a name="588"><span class="lineNum">     588 </span>            :     QPaintEngine *paintEngine() const override;</a>
<a name="589"><span class="lineNum">     589 </span>            : </a>
<a name="590"><span class="lineNum">     590 </span>            :     void ensurePolished() const;</a>
<a name="591"><span class="lineNum">     591 </span>            : </a>
<a name="592"><span class="lineNum">     592 </span>            :     bool isAncestorOf(const QWidget *child) const;</a>
<a name="593"><span class="lineNum">     593 </span>            : </a>
<a name="594"><span class="lineNum">     594 </span>            : #ifdef QT_KEYPAD_NAVIGATION</a>
<a name="595"><span class="lineNum">     595 </span>            :     bool hasEditFocus() const;</a>
<a name="596"><span class="lineNum">     596 </span>            :     void setEditFocus(bool on);</a>
<a name="597"><span class="lineNum">     597 </span>            : #endif</a>
<a name="598"><span class="lineNum">     598 </span>            : </a>
<a name="599"><span class="lineNum">     599 </span>            :     bool autoFillBackground() const;</a>
<a name="600"><span class="lineNum">     600 </span>            :     void setAutoFillBackground(bool enabled);</a>
<a name="601"><span class="lineNum">     601 </span>            : </a>
<a name="602"><span class="lineNum">     602 </span>            :     QBackingStore *backingStore() const;</a>
<a name="603"><span class="lineNum">     603 </span>            : </a>
<a name="604"><span class="lineNum">     604 </span>            :     QWindow *windowHandle() const;</a>
<a name="605"><span class="lineNum">     605 </span>            :     QScreen *screen() const;</a>
<a name="606"><span class="lineNum">     606 </span>            : </a>
<a name="607"><span class="lineNum">     607 </span>            :     static QWidget *createWindowContainer(QWindow *window, QWidget *parent=nullptr, Qt::WindowFlags flags=Qt::WindowFlags());</a>
<a name="608"><span class="lineNum">     608 </span>            : </a>
<a name="609"><span class="lineNum">     609 </span>            :     friend class QDesktopScreenWidget;</a>
<a name="610"><span class="lineNum">     610 </span>            : </a>
<a name="611"><span class="lineNum">     611 </span>            : Q_SIGNALS:</a>
<a name="612"><span class="lineNum">     612 </span>            :     void windowTitleChanged(const QString &amp;title);</a>
<a name="613"><span class="lineNum">     613 </span>            :     void windowIconChanged(const QIcon &amp;icon);</a>
<a name="614"><span class="lineNum">     614 </span>            :     void windowIconTextChanged(const QString &amp;iconText);</a>
<a name="615"><span class="lineNum">     615 </span>            :     void customContextMenuRequested(const QPoint &amp;pos);</a>
<a name="616"><span class="lineNum">     616 </span>            : </a>
<a name="617"><span class="lineNum">     617 </span>            : protected:</a>
<a name="618"><span class="lineNum">     618 </span>            :     // Event handlers</a>
<a name="619"><span class="lineNum">     619 </span>            :     bool event(QEvent *event) override;</a>
<a name="620"><span class="lineNum">     620 </span>            :     virtual void mousePressEvent(QMouseEvent *event);</a>
<a name="621"><span class="lineNum">     621 </span>            :     virtual void mouseReleaseEvent(QMouseEvent *event);</a>
<a name="622"><span class="lineNum">     622 </span>            :     virtual void mouseDoubleClickEvent(QMouseEvent *event);</a>
<a name="623"><span class="lineNum">     623 </span>            :     virtual void mouseMoveEvent(QMouseEvent *event);</a>
<a name="624"><span class="lineNum">     624 </span>            : #if QT_CONFIG(wheelevent)</a>
<a name="625"><span class="lineNum">     625 </span>            :     virtual void wheelEvent(QWheelEvent *event);</a>
<a name="626"><span class="lineNum">     626 </span>            : #endif</a>
<a name="627"><span class="lineNum">     627 </span>            :     virtual void keyPressEvent(QKeyEvent *event);</a>
<a name="628"><span class="lineNum">     628 </span>            :     virtual void keyReleaseEvent(QKeyEvent *event);</a>
<a name="629"><span class="lineNum">     629 </span>            :     virtual void focusInEvent(QFocusEvent *event);</a>
<a name="630"><span class="lineNum">     630 </span>            :     virtual void focusOutEvent(QFocusEvent *event);</a>
<a name="631"><span class="lineNum">     631 </span>            :     virtual void enterEvent(QEvent *event);</a>
<a name="632"><span class="lineNum">     632 </span>            :     virtual void leaveEvent(QEvent *event);</a>
<a name="633"><span class="lineNum">     633 </span>            :     virtual void paintEvent(QPaintEvent *event);</a>
<a name="634"><span class="lineNum">     634 </span>            :     virtual void moveEvent(QMoveEvent *event);</a>
<a name="635"><span class="lineNum">     635 </span>            :     virtual void resizeEvent(QResizeEvent *event);</a>
<a name="636"><span class="lineNum">     636 </span>            :     virtual void closeEvent(QCloseEvent *event);</a>
<a name="637"><span class="lineNum">     637 </span>            : #ifndef QT_NO_CONTEXTMENU</a>
<a name="638"><span class="lineNum">     638 </span>            :     virtual void contextMenuEvent(QContextMenuEvent *event);</a>
<a name="639"><span class="lineNum">     639 </span>            : #endif</a>
<a name="640"><span class="lineNum">     640 </span>            : #if QT_CONFIG(tabletevent)</a>
<a name="641"><span class="lineNum">     641 </span>            :     virtual void tabletEvent(QTabletEvent *event);</a>
<a name="642"><span class="lineNum">     642 </span>            : #endif</a>
<a name="643"><span class="lineNum">     643 </span>            : #ifndef QT_NO_ACTION</a>
<a name="644"><span class="lineNum">     644 </span>            :     virtual void actionEvent(QActionEvent *event);</a>
<a name="645"><span class="lineNum">     645 </span>            : #endif</a>
<a name="646"><span class="lineNum">     646 </span>            : </a>
<a name="647"><span class="lineNum">     647 </span>            : #if QT_CONFIG(draganddrop)</a>
<a name="648"><span class="lineNum">     648 </span>            :     virtual void dragEnterEvent(QDragEnterEvent *event);</a>
<a name="649"><span class="lineNum">     649 </span>            :     virtual void dragMoveEvent(QDragMoveEvent *event);</a>
<a name="650"><span class="lineNum">     650 </span>            :     virtual void dragLeaveEvent(QDragLeaveEvent *event);</a>
<a name="651"><span class="lineNum">     651 </span>            :     virtual void dropEvent(QDropEvent *event);</a>
<a name="652"><span class="lineNum">     652 </span>            : #endif</a>
<a name="653"><span class="lineNum">     653 </span>            : </a>
<a name="654"><span class="lineNum">     654 </span>            :     virtual void showEvent(QShowEvent *event);</a>
<a name="655"><span class="lineNum">     655 </span>            :     virtual void hideEvent(QHideEvent *event);</a>
<a name="656"><span class="lineNum">     656 </span>            : </a>
<a name="657"><span class="lineNum">     657 </span>            : #if QT_VERSION &gt;= QT_VERSION_CHECK(6, 0, 0)</a>
<a name="658"><span class="lineNum">     658 </span>            :     virtual bool nativeEvent(const QByteArray &amp;eventType, void *message, qintptr *result);</a>
<a name="659"><span class="lineNum">     659 </span>            : #else</a>
<a name="660"><span class="lineNum">     660 </span>            :     virtual bool nativeEvent(const QByteArray &amp;eventType, void *message, long *result);</a>
<a name="661"><span class="lineNum">     661 </span>            : #endif</a>
<a name="662"><span class="lineNum">     662 </span>            : </a>
<a name="663"><span class="lineNum">     663 </span>            :     // Misc. protected functions</a>
<a name="664"><span class="lineNum">     664 </span>            :     virtual void changeEvent(QEvent *);</a>
<a name="665"><span class="lineNum">     665 </span>            : </a>
<a name="666"><span class="lineNum">     666 </span>            :     int metric(PaintDeviceMetric) const override;</a>
<a name="667"><span class="lineNum">     667 </span>            :     void initPainter(QPainter *painter) const override;</a>
<a name="668"><span class="lineNum">     668 </span>            :     QPaintDevice *redirected(QPoint *offset) const override;</a>
<a name="669"><span class="lineNum">     669 </span>            :     QPainter *sharedPainter() const override;</a>
<a name="670"><span class="lineNum">     670 </span>            : </a>
<a name="671"><span class="lineNum">     671 </span>            :     virtual void inputMethodEvent(QInputMethodEvent *);</a>
<a name="672"><span class="lineNum">     672 </span>            : public:</a>
<a name="673"><span class="lineNum">     673 </span>            :     virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;</a>
<a name="674"><span class="lineNum">     674 </span>            : </a>
<a name="675"><span class="lineNum">     675 </span>            :     Qt::InputMethodHints inputMethodHints() const;</a>
<a name="676"><span class="lineNum">     676 </span>            :     void setInputMethodHints(Qt::InputMethodHints hints);</a>
<a name="677"><span class="lineNum">     677 </span>            : </a>
<a name="678"><span class="lineNum">     678 </span>            : protected Q_SLOTS:</a>
<a name="679"><span class="lineNum">     679 </span>            :     void updateMicroFocus();</a>
<a name="680"><span class="lineNum">     680 </span>            : protected:</a>
<a name="681"><span class="lineNum">     681 </span>            : </a>
<a name="682"><span class="lineNum">     682 </span>            :     void create(WId = 0, bool initializeWindow = true,</a>
<a name="683"><span class="lineNum">     683 </span>            :                          bool destroyOldWindow = true);</a>
<a name="684"><span class="lineNum">     684 </span>            :     void destroy(bool destroyWindow = true,</a>
<a name="685"><span class="lineNum">     685 </span>            :                  bool destroySubWindows = true);</a>
<a name="686"><span class="lineNum">     686 </span>            : </a>
<a name="687"><span class="lineNum">     687 </span>            :     friend class QDataWidgetMapperPrivate; // for access to focusNextPrevChild</a>
<a name="688"><span class="lineNum">     688 </span>            :     virtual bool focusNextPrevChild(bool next);</a>
<a name="689"><span class="lineNum">     689 </span>            :     inline bool focusNextChild() { return focusNextPrevChild(true); }</a>
<a name="690"><span class="lineNum">     690 </span>            :     inline bool focusPreviousChild() { return focusNextPrevChild(false); }</a>
<a name="691"><span class="lineNum">     691 </span>            : </a>
<a name="692"><span class="lineNum">     692 </span>            : protected:</a>
<a name="693"><span class="lineNum">     693 </span>            :     QWidget(QWidgetPrivate &amp;d, QWidget* parent, Qt::WindowFlags f);</a>
<a name="694"><span class="lineNum">     694 </span>            : private:</a>
<a name="695"><span class="lineNum">     695 </span>            :     void setBackingStore(QBackingStore *store);</a>
<a name="696"><span class="lineNum">     696 </span>            : </a>
<a name="697"><span class="lineNum">     697 </span>            :     bool testAttribute_helper(Qt::WidgetAttribute) const;</a>
<a name="698"><span class="lineNum">     698 </span>            : </a>
<a name="699"><span class="lineNum">     699 </span>            :     QLayout *takeLayout();</a>
<a name="700"><span class="lineNum">     700 </span>            : </a>
<a name="701"><span class="lineNum">     701 </span>            :     friend class QBackingStoreDevice;</a>
<a name="702"><span class="lineNum">     702 </span>            :     friend class QWidgetRepaintManager;</a>
<a name="703"><span class="lineNum">     703 </span>            :     friend class QApplication;</a>
<a name="704"><span class="lineNum">     704 </span>            :     friend class QApplicationPrivate;</a>
<a name="705"><span class="lineNum">     705 </span>            :     friend class QGuiApplication;</a>
<a name="706"><span class="lineNum">     706 </span>            :     friend class QGuiApplicationPrivate;</a>
<a name="707"><span class="lineNum">     707 </span>            :     friend class QBaseApplication;</a>
<a name="708"><span class="lineNum">     708 </span>            :     friend class QPainter;</a>
<a name="709"><span class="lineNum">     709 </span>            :     friend class QPainterPrivate;</a>
<a name="710"><span class="lineNum">     710 </span>            :     friend class QPixmap; // for QPixmap::fill()</a>
<a name="711"><span class="lineNum">     711 </span>            :     friend class QFontMetrics;</a>
<a name="712"><span class="lineNum">     712 </span>            :     friend class QFontInfo;</a>
<a name="713"><span class="lineNum">     713 </span>            :     friend class QLayout;</a>
<a name="714"><span class="lineNum">     714 </span>            :     friend class QWidgetItem;</a>
<a name="715"><span class="lineNum">     715 </span>            :     friend class QWidgetItemV2;</a>
<a name="716"><span class="lineNum">     716 </span>            :     friend class QGLContext;</a>
<a name="717"><span class="lineNum">     717 </span>            :     friend class QGLWidget;</a>
<a name="718"><span class="lineNum">     718 </span>            :     friend class QGLWindowSurface;</a>
<a name="719"><span class="lineNum">     719 </span>            :     friend class QX11PaintEngine;</a>
<a name="720"><span class="lineNum">     720 </span>            :     friend class QWin32PaintEngine;</a>
<a name="721"><span class="lineNum">     721 </span>            :     friend class QShortcutPrivate;</a>
<a name="722"><span class="lineNum">     722 </span>            :     friend class QWindowSurface;</a>
<a name="723"><span class="lineNum">     723 </span>            :     friend class QGraphicsProxyWidget;</a>
<a name="724"><span class="lineNum">     724 </span>            :     friend class QGraphicsProxyWidgetPrivate;</a>
<a name="725"><span class="lineNum">     725 </span>            :     friend class QStyleSheetStyle;</a>
<a name="726"><span class="lineNum">     726 </span>            :     friend struct QWidgetExceptionCleaner;</a>
<a name="727"><span class="lineNum">     727 </span>            :     friend class QWidgetWindow;</a>
<a name="728"><span class="lineNum">     728 </span>            :     friend class QAccessibleWidget;</a>
<a name="729"><span class="lineNum">     729 </span>            :     friend class QAccessibleTable;</a>
<a name="730"><span class="lineNum">     730 </span>            :     friend class QAccessibleTabButton;</a>
<a name="731"><span class="lineNum">     731 </span>            : #ifndef QT_NO_GESTURES</a>
<a name="732"><span class="lineNum">     732 </span>            :     friend class QGestureManager;</a>
<a name="733"><span class="lineNum">     733 </span>            :     friend class QWinNativePanGestureRecognizer;</a>
<a name="734"><span class="lineNum">     734 </span>            : #endif // QT_NO_GESTURES</a>
<a name="735"><span class="lineNum">     735 </span>            :     friend class QWidgetEffectSourcePrivate;</a>
<a name="736"><span class="lineNum">     736 </span>            : </a>
<a name="737"><span class="lineNum">     737 </span>            : #ifdef Q_OS_MAC</a>
<a name="738"><span class="lineNum">     738 </span>            :     friend bool qt_mac_is_metal(const QWidget *w);</a>
<a name="739"><span class="lineNum">     739 </span>            : #endif</a>
<a name="740"><span class="lineNum">     740 </span>            :     friend Q_WIDGETS_EXPORT QWidgetData *qt_qwidget_data(QWidget *widget);</a>
<a name="741"><span class="lineNum">     741 </span>            :     friend Q_WIDGETS_EXPORT QWidgetPrivate *qt_widget_private(QWidget *widget);</a>
<a name="742"><span class="lineNum">     742 </span>            : </a>
<a name="743"><span class="lineNum">     743 </span>            : private:</a>
<a name="744"><span class="lineNum">     744 </span>            :     Q_DISABLE_COPY(QWidget)</a>
<a name="745"><span class="lineNum">     745 </span>            :     Q_PRIVATE_SLOT(d_func(), void _q_showIfNotHidden())</a>
<a name="746"><span class="lineNum">     746 </span>            : </a>
<a name="747"><span class="lineNum">     747 </span>            :     QWidgetData *data;</a>
<a name="748"><span class="lineNum">     748 </span>            : };</a>
<a name="749"><span class="lineNum">     749 </span>            : </a>
<a name="750"><span class="lineNum">     750 </span>            : Q_DECLARE_OPERATORS_FOR_FLAGS(QWidget::RenderFlags)</a>
<a name="751"><span class="lineNum">     751 </span>            : </a>
<a name="752"><span class="lineNum">     752 </span>            : #ifndef Q_QDOC</a>
<a name="753"><span class="lineNum">     753 </span>            : template &lt;&gt; inline QWidget *qobject_cast&lt;QWidget*&gt;(QObject *o)</a>
<a name="754"><span class="lineNum">     754 </span>            : {</a>
<a name="755"><span class="lineNum">     755 </span>            :     if (!o || !o-&gt;isWidgetType()) return nullptr;</a>
<a name="756"><span class="lineNum">     756 </span>            :     return static_cast&lt;QWidget*&gt;(o);</a>
<a name="757"><span class="lineNum">     757 </span>            : }</a>
<a name="758"><span class="lineNum">     758 </span>            : template &lt;&gt; inline const QWidget *qobject_cast&lt;const QWidget*&gt;(const QObject *o)</a>
<a name="759"><span class="lineNum">     759 </span>            : {</a>
<a name="760"><span class="lineNum">     760 </span>            :     if (!o || !o-&gt;isWidgetType()) return nullptr;</a>
<a name="761"><span class="lineNum">     761 </span>            :     return static_cast&lt;const QWidget*&gt;(o);</a>
<a name="762"><span class="lineNum">     762 </span>            : }</a>
<a name="763"><span class="lineNum">     763 </span>            : #endif // !Q_QDOC</a>
<a name="764"><span class="lineNum">     764 </span>            : </a>
<a name="765"><span class="lineNum">     765 </span>            : inline QWidget *QWidget::childAt(int ax, int ay) const</a>
<a name="766"><span class="lineNum">     766 </span>            : { return childAt(QPoint(ax, ay)); }</a>
<a name="767"><span class="lineNum">     767 </span>            : </a>
<a name="768"><span class="lineNum">     768 </span>            : inline Qt::WindowType QWidget::windowType() const</a>
<a name="769"><span class="lineNum">     769 </span>            : { return static_cast&lt;Qt::WindowType&gt;(int(data-&gt;window_flags &amp; Qt::WindowType_Mask)); }</a>
<a name="770"><span class="lineNum">     770 </span>            : inline Qt::WindowFlags QWidget::windowFlags() const</a>
<a name="771"><span class="lineNum">     771 </span>            : { return data-&gt;window_flags; }</a>
<a name="772"><span class="lineNum">     772 </span>            : </a>
<a name="773"><span class="lineNum">     773 </span>            : inline bool QWidget::isTopLevel() const</a>
<a name="774"><span class="lineNum">     774 </span>            : { return (windowType() &amp; Qt::Window); }</a>
<a name="775"><span class="lineNum">     775 </span>            : </a>
<a name="776"><span class="lineNum">     776 </span>            : inline bool QWidget::isWindow() const</a>
<a name="777"><span class="lineNum">     777 </span>            : { return (windowType() &amp; Qt::Window); }</a>
<a name="778"><span class="lineNum">     778 </span>            : </a>
<a name="779"><span class="lineNum">     779 </span>            : inline bool QWidget::isEnabled() const</a>
<a name="780"><span class="lineNum">     780 </span>            : { return !testAttribute(Qt::WA_Disabled); }</a>
<a name="781"><span class="lineNum">     781 </span>            : </a>
<a name="782"><span class="lineNum">     782 </span>            : inline bool QWidget::isModal() const</a>
<a name="783"><span class="lineNum">     783 </span>            : { return data-&gt;window_modality != Qt::NonModal; }</a>
<a name="784"><span class="lineNum">     784 </span>            : </a>
<a name="785"><span class="lineNum">     785 </span>            : #if QT_DEPRECATED_SINCE(5, 13)</a>
<a name="786"><span class="lineNum">     786 </span>            : inline bool QWidget::isEnabledToTLW() const</a>
<a name="787"><span class="lineNum">     787 </span>            : { return isEnabled(); }</a>
<a name="788"><span class="lineNum">     788 </span>            : #endif</a>
<a name="789"><span class="lineNum">     789 </span>            : </a>
<a name="790"><span class="lineNum">     790 </span>            : inline int QWidget::minimumWidth() const</a>
<a name="791"><span class="lineNum">     791 </span>            : { return minimumSize().width(); }</a>
<a name="792"><span class="lineNum">     792 </span>            : </a>
<a name="793"><span class="lineNum">     793 </span>            : inline int QWidget::minimumHeight() const</a>
<a name="794"><span class="lineNum">     794 </span>            : { return minimumSize().height(); }</a>
<a name="795"><span class="lineNum">     795 </span>            : </a>
<a name="796"><span class="lineNum">     796 </span>            : inline int QWidget::maximumWidth() const</a>
<a name="797"><span class="lineNum">     797 </span>            : { return maximumSize().width(); }</a>
<a name="798"><span class="lineNum">     798 </span>            : </a>
<a name="799"><span class="lineNum">     799 </span>            : inline int QWidget::maximumHeight() const</a>
<a name="800"><span class="lineNum">     800 </span>            : { return maximumSize().height(); }</a>
<a name="801"><span class="lineNum">     801 </span>            : </a>
<a name="802"><span class="lineNum">     802 </span>            : inline void QWidget::setMinimumSize(const QSize &amp;s)</a>
<a name="803"><span class="lineNum">     803 </span>            : { setMinimumSize(s.width(),s.height()); }</a>
<a name="804"><span class="lineNum">     804 </span>            : </a>
<a name="805"><span class="lineNum">     805 </span>            : inline void QWidget::setMaximumSize(const QSize &amp;s)</a>
<a name="806"><span class="lineNum">     806 </span>            : { setMaximumSize(s.width(),s.height()); }</a>
<a name="807"><span class="lineNum">     807 </span>            : </a>
<a name="808"><span class="lineNum">     808 </span>            : inline void QWidget::setSizeIncrement(const QSize &amp;s)</a>
<a name="809"><span class="lineNum">     809 </span>            : { setSizeIncrement(s.width(),s.height()); }</a>
<a name="810"><span class="lineNum">     810 </span>            : </a>
<a name="811"><span class="lineNum">     811 </span>            : inline void QWidget::setBaseSize(const QSize &amp;s)</a>
<a name="812"><span class="lineNum">     812 </span>            : { setBaseSize(s.width(),s.height()); }</a>
<a name="813"><span class="lineNum">     813 </span>            : </a>
<a name="814"><span class="lineNum">     814 </span>            : inline const QFont &amp;QWidget::font() const</a>
<a name="815"><span class="lineNum">     815 </span>            : { return data-&gt;fnt; }</a>
<a name="816"><span class="lineNum">     816 </span>            : </a>
<a name="817"><span class="lineNum">     817 </span>            : inline QFontMetrics QWidget::fontMetrics() const</a>
<a name="818"><span class="lineNum">     818 </span>            : { return QFontMetrics(data-&gt;fnt); }</a>
<a name="819"><span class="lineNum">     819 </span>            : </a>
<a name="820"><span class="lineNum">     820 </span>            : inline QFontInfo QWidget::fontInfo() const</a>
<a name="821"><span class="lineNum">     821 </span>            : { return QFontInfo(data-&gt;fnt); }</a>
<a name="822"><span class="lineNum">     822 </span>            : </a>
<a name="823"><span class="lineNum">     823 </span>            : inline void QWidget::setMouseTracking(bool enable)</a>
<a name="824"><span class="lineNum">     824 </span>            : { setAttribute(Qt::WA_MouseTracking, enable); }</a>
<a name="825"><span class="lineNum">     825 </span>            : </a>
<a name="826"><span class="lineNum">     826 </span>            : inline bool QWidget::hasMouseTracking() const</a>
<a name="827"><span class="lineNum">     827 </span>            : { return testAttribute(Qt::WA_MouseTracking); }</a>
<a name="828"><span class="lineNum">     828 </span>            : </a>
<a name="829"><span class="lineNum">     829 </span>            : inline bool QWidget::underMouse() const</a>
<a name="830"><span class="lineNum">     830 </span>            : { return testAttribute(Qt::WA_UnderMouse); }</a>
<a name="831"><span class="lineNum">     831 </span>            : </a>
<a name="832"><span class="lineNum">     832 </span>            : inline void QWidget::setTabletTracking(bool enable)</a>
<a name="833"><span class="lineNum">     833 </span>            : { setAttribute(Qt::WA_TabletTracking, enable); }</a>
<a name="834"><span class="lineNum">     834 </span>            : </a>
<a name="835"><span class="lineNum">     835 </span>            : inline bool QWidget::hasTabletTracking() const</a>
<a name="836"><span class="lineNum">     836 </span>            : { return testAttribute(Qt::WA_TabletTracking); }</a>
<a name="837"><span class="lineNum">     837 </span>            : </a>
<a name="838"><span class="lineNum">     838 </span>            : inline bool QWidget::updatesEnabled() const</a>
<a name="839"><span class="lineNum">     839 </span>            : { return !testAttribute(Qt::WA_UpdatesDisabled); }</a>
<a name="840"><span class="lineNum">     840 </span>            : </a>
<a name="841"><span class="lineNum">     841 </span>            : inline void QWidget::update(int ax, int ay, int aw, int ah)</a>
<a name="842"><span class="lineNum">     842 </span>            : { update(QRect(ax, ay, aw, ah)); }</a>
<a name="843"><span class="lineNum">     843 </span>            : </a>
<a name="844"><span class="lineNum">     844 </span>            : inline bool QWidget::isVisible() const</a>
<a name="845"><span class="lineNum">     845 </span>            : { return testAttribute(Qt::WA_WState_Visible); }</a>
<a name="846"><span class="lineNum">     846 </span>            : </a>
<a name="847"><span class="lineNum">     847 </span>            : inline bool QWidget::isHidden() const</a>
<a name="848"><span class="lineNum">     848 </span>            : { return testAttribute(Qt::WA_WState_Hidden); }</a>
<a name="849"><span class="lineNum">     849 </span>            : </a>
<a name="850"><span class="lineNum">     850 </span><span class="lineCov">          3 : inline void QWidget::move(int ax, int ay)</span></a>
<a name="851"><span class="lineNum">     851 </span><span class="lineCov">          3 : { move(QPoint(ax, ay)); }</span></a>
<a name="852"><span class="lineNum">     852 </span>            : </a>
<a name="853"><span class="lineNum">     853 </span><span class="lineCov">          1 : inline void QWidget::resize(int w, int h)</span></a>
<a name="854"><span class="lineNum">     854 </span><span class="lineCov">          1 : { resize(QSize(w, h)); }</span></a>
<a name="855"><span class="lineNum">     855 </span>            : </a>
<a name="856"><span class="lineNum">     856 </span>            : inline void QWidget::setGeometry(int ax, int ay, int aw, int ah)</a>
<a name="857"><span class="lineNum">     857 </span>            : { setGeometry(QRect(ax, ay, aw, ah)); }</a>
<a name="858"><span class="lineNum">     858 </span>            : </a>
<a name="859"><span class="lineNum">     859 </span>            : inline QRect QWidget::rect() const</a>
<a name="860"><span class="lineNum">     860 </span>            : { return QRect(0,0,data-&gt;crect.width(),data-&gt;crect.height()); }</a>
<a name="861"><span class="lineNum">     861 </span>            : </a>
<a name="862"><span class="lineNum">     862 </span>            : inline const QRect &amp;QWidget::geometry() const</a>
<a name="863"><span class="lineNum">     863 </span>            : { return data-&gt;crect; }</a>
<a name="864"><span class="lineNum">     864 </span>            : </a>
<a name="865"><span class="lineNum">     865 </span>            : inline QSize QWidget::size() const</a>
<a name="866"><span class="lineNum">     866 </span>            : { return data-&gt;crect.size(); }</a>
<a name="867"><span class="lineNum">     867 </span>            : </a>
<a name="868"><span class="lineNum">     868 </span>            : inline int QWidget::width() const</a>
<a name="869"><span class="lineNum">     869 </span>            : { return data-&gt;crect.width(); }</a>
<a name="870"><span class="lineNum">     870 </span>            : </a>
<a name="871"><span class="lineNum">     871 </span>            : inline int QWidget::height() const</a>
<a name="872"><span class="lineNum">     872 </span>            : { return data-&gt;crect.height(); }</a>
<a name="873"><span class="lineNum">     873 </span>            : </a>
<a name="874"><span class="lineNum">     874 </span>            : inline QWidget *QWidget::parentWidget() const</a>
<a name="875"><span class="lineNum">     875 </span>            : { return static_cast&lt;QWidget *&gt;(QObject::parent()); }</a>
<a name="876"><span class="lineNum">     876 </span>            : </a>
<a name="877"><span class="lineNum">     877 </span>            : inline void QWidget::setSizePolicy(QSizePolicy::Policy hor, QSizePolicy::Policy ver)</a>
<a name="878"><span class="lineNum">     878 </span>            : { setSizePolicy(QSizePolicy(hor, ver)); }</a>
<a name="879"><span class="lineNum">     879 </span>            : </a>
<a name="880"><span class="lineNum">     880 </span>            : inline bool QWidget::testAttribute(Qt::WidgetAttribute attribute) const</a>
<a name="881"><span class="lineNum">     881 </span>            : {</a>
<a name="882"><span class="lineNum">     882 </span>            :     if (attribute &lt; int(8*sizeof(uint)))</a>
<a name="883"><span class="lineNum">     883 </span>            :         return data-&gt;widget_attributes &amp; (1&lt;&lt;attribute);</a>
<a name="884"><span class="lineNum">     884 </span>            :     return testAttribute_helper(attribute);</a>
<a name="885"><span class="lineNum">     885 </span>            : }</a>
<a name="886"><span class="lineNum">     886 </span>            : </a>
<a name="887"><span class="lineNum">     887 </span>            : </a>
<a name="888"><span class="lineNum">     888 </span>            : #define QWIDGETSIZE_MAX ((1&lt;&lt;24)-1)</a>
<a name="889"><span class="lineNum">     889 </span>            : </a>
<a name="890"><span class="lineNum">     890 </span>            : #ifndef QT_NO_DEBUG_STREAM</a>
<a name="891"><span class="lineNum">     891 </span>            : Q_WIDGETS_EXPORT QDebug operator&lt;&lt;(QDebug, const QWidget *);</a>
<a name="892"><span class="lineNum">     892 </span>            : #endif</a>
<a name="893"><span class="lineNum">     893 </span>            : </a>
<a name="894"><span class="lineNum">     894 </span>            : QT_END_NAMESPACE</a>
<a name="895"><span class="lineNum">     895 </span>            : </a>
<a name="896"><span class="lineNum">     896 </span>            : #endif // QWIDGET_H</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
